CT_RANoTankSalvation_Setup = {
	isMT = false;
	locale = false;
	showRemoveMessage = true;
};

CT_RANoTankSalvation_BuffFilter = "HELPFUL";

CT_RANoTankSalvation_Classes = {
	"WARRIOR";
	"DRUID";
};

function CT_RANoTankSalvation_OnLoad(frame)
	local _, class = UnitClass("player");
	local ok = false;
	for k, v in CT_RANoTankSalvation_Classes do
		if ( v == class ) then
			ok = true;
			break;
		end
	end
	if ( ok ) then
		if ( CT_RATarget_UpdateStats ) then
			CT_RANoTankSalvation_CT_RATarget_UpdateStats_Saved = CT_RATarget_UpdateStats;
			CT_RATarget_UpdateStats = CT_RANoTankSalvation_CT_RATarget_UpdateStats;
		end	
		local cmd = "CT_RANOTANKSALVATION";
		for k, v in CT_RANOTANKSALVATION_SLASHCOMMANDS do
			setglobal("SLASH_"..cmd..k, v);
		end
		SlashCmdList[cmd] = CT_RANoTankSalvation_SlashCommand;
		frame:SetScript("OnEvent", CT_RANoTankSalvation_Event);
		frame:RegisterEvent("RAID_ROSTER_UPDATE");
		CT_RANoTankSalvation_UpdateMTStatus();
		local l = GetLocale();
		if ( l == "enGB" ) then
			l = "enUS";
		end
		CT_RANoTankSalvation_Setup.locale = l;
		if ( CT_RANoTankSalvation_Setup.locale == CT_RANOTANKSALVATION_LOCALE ) then
			--CT_RANoTankSalvation_UpdateMTStatus();
		else
			frame:RegisterEvent("PLAYER_AURAS_CHANGED");
		end
		CT_RANoTankSalvation_UpdateMTStatus();
	else
		ChatFrame1:AddMessage(CT_RANOTANKSALVATION_MSG_WRONG_CLASS);
	end
end

function CT_RANoTankSalvation_UpdateMTStatus()
	local wasMT = CT_RANoTankSalvation_Setup.isMT;
	
	CT_RANoTankSalvation_Setup.isMT = CT_RANoTankSalvation_IsOnMTList();
	
	if ( CT_RANoTankSalvation_Setup.isMT ) then
		CT_RANoTankSalvation_ScanAndRemoveSalvation();
	end
	
	if ( wasMT ~= CT_RANoTankSalvation_Setup.isMT ) then
		local frame = CT_RANoTankSalvationFrame;
		if ( CT_RANoTankSalvation_Setup.isMT ) then
			frame:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
		else
			frame:UnregisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
		end
	end
end

function CT_RANoTankSalvation_CT_RATarget_UpdateStats(p1,p2,p3)
	CT_RANoTankSalvation_UpdateMTStatus();
	return CT_RANoTankSalvation_CT_RATarget_UpdateStats_Saved(p1,p2,p3);
end

function CT_RANoTankSalvation_OnEvent()
	if ( event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS" ) then
		if ( CT_RANoTankSalvation_Setup.isMT ) then
			for effect in string.gfind(arg1, CT_RANOTANKSALVATION_YOU_GAIN) do
				for k, v in CT_RANOTANKSALVATION_SALVATIONS	do
					if ( v == effect ) then
						CT_RANoTankSalvation_ScanAndRemoveSalvation();
						break;
					end
				end
			end
		end
		return;
	end
	if ( event == "RAID_ROSTER_UPDATE" ) then
		CT_RANoTankSalvation_UpdateMTStatus();
		return;
	end
	if ( event == "PLAYER_AURAS_CHANGED" ) then
		if ( CT_RANoTankSalvation_Setup.isMT ) then
			CT_RANoTankSalvation_ScanAndRemoveSalvation();
		end
		return;
	end
end

function CT_RANoTankSalvation_IsOnMTList()
	if ( not CT_RATarget ) or ( not CT_RATarget.MainTanks ) then
		return false;
	end
	for k, v in pairs(CT_RATarget.MainTanks) do
		if ( UnitIsUnit("raid" .. ( v[1] or ""), "player" ) ) then
			return true;
		end
	end
	return false;
end

function CT_RANoTankSalvation_Print(msg, r, g, b)
	if ( not r ) then r = 1; end
	if ( not g ) then r = 1; end
	if ( not b ) then r = 0.1; end
	ChatFrame1:AddMessage(msg, r, g, b, 1);
end

function CT_RANoTankSalvation_ScanAndRemoveSalvation()
	local removed = false;
	local index,i,t,n;
	for i = 0, 24 do
		index = GetPlayerBuff(i, CT_RANoTankSalvation_BuffFilter);
		if ( index >= 0 ) then
			t = GetPlayerBuffTexture(index);
			if ( t ) then
				n = CT_RANOTANKSALVATION_SALVATIONS[t];
				if ( n ) then
					if ( CT_RANoTankSalvation_Setup.locale == CT_RANOTANKSALVATION_LOCALE ) then
						CT_RATooltip:SetPlayerBuff(index);
						if ( CT_RATooltipTextLeft1:GetText() == n ) then
							if ( CT_RANoTankSalvation_Setup.showRemoveMessage ) then 
								CT_RANoTankSalvation_Print(CT_RANOTANKSALVATION_MSG_REMOVED);
							end
							CancelPlayerBuff(index);
							return true;
						end
					else
						if ( not removed ) and ( CT_RANoTankSalvation_Setup.showRemoveMessage ) then 
							CT_RANoTankSalvation_Print(CT_RANOTANKSALVATION_MSG_REMOVED);
						end
						CancelPlayerBuff(index);
						removed = true;
					end
				end
			end
		else
			break;
		end
	end
	return removed;
end

function CT_RANoTankSalvation_SlashCommand(msg)
	local state = CT_RANOTANKSALVATION_STATE_DISABLED;
	if ( not CT_RANoTankSalvation_Setup.showRemoveMessage ) then
		state = CT_RANOTANKSALVATION_STATE_ENABLED;
		CT_RANoTankSalvation_Setup.showRemoveMessage = true;
	else
		CT_RANoTankSalvation_Setup.showRemoveMessage = false;
	end
	CT_RANoTankSalvation_Print(format(CT_RANOTANKSALVATION_MSG_STATE, state));
end

local frame = CreateFrame("Frame", "CT_RANoTankSalvationFrame");
CT_RANoTankSalvation_OnLoad(frame);


